<?php
/*
Plugin Name: درگاه بانک ملت ووکامرس
Plugin URI: http://20script.ir
Description: افزونه درگاه پرداخت بانک ملت فروشگاه ساز ووکامرس
Version: 3.2
Author: WooCommerce Persian
Author URI: http://20script.ir

 */
require_once("nusoap.php");
add_action('plugins_loaded', 'woocommerce_mellat_init', 0);

function woocommerce_mellat_init() {

    if ( !class_exists( 'WC_Payment_Gateway' ) ) return;

	if($_GET['msg']!=''){
        add_action('the_content', 'showMessagemellat');
    }

    function showMessagemellat($content){
            return '<div class="box '.htmlentities($_GET['type']).'-box">'.base64_decode($_GET['msg']).'</div>'.$content;
    }

    class WC_Mellat_Pay extends WC_Payment_Gateway {
	protected $msg = array();
        public function __construct(){
            // Go wild in here
            $this -> id = 'mellat';
            $this -> method_title = __('&#1583;&#1585;&#1711;&#1575;&#1607; &#1605;&#1604;&#1578;', 'mrova');
            $this -> icon = WP_PLUGIN_URL . "/" . plugin_basename(dirname(__FILE__)) . '/images/logo.png';
            $this -> has_fields = false;
            $this -> init_form_fields();
            $this -> init_settings();
            $this -> title = $this -> settings['title'];
            $this -> terminal_id = $this -> settings['terminal_id'];
            $this -> username_t = $this -> settings['username_t'];
            $this -> password_t = $this -> settings['password_t'];
            $this -> vahed = $this -> settings['vahed'];
            $this -> redirect_page_id = $this -> settings['redirect_page_id'];
            
            $this -> msg['reversal'] = "";
			$this -> msg['status'] = "";
			$this -> msg['message'] = "";
            $this -> msg['class'] = "";
            add_action( 'woocommerce_api_' . strtolower( get_class( $this ) ), array( $this, 'check_mellat_response' ) );
            add_action('valid-mellat-request', array($this, 'successful_request'));
            if ( version_compare( WOOCOMMERCE_VERSION, '2.0.0', '>=' ) ) {
                add_action( 'woocommerce_update_options_payment_gateways_' . $this->id, array( $this, 'process_admin_options' ) );
             } else {
                add_action( 'woocommerce_update_options_payment_gateways', array( $this, 'process_admin_options' ) );
            }
            add_action('woocommerce_receipt_mellat', array($this, 'receipt_page'));
        }

        function init_form_fields(){

            $this -> form_fields = array(
                'enabled' => array(
                    'title' => __('فعال / غیر فعال کردن', 'mrova'),
                    'type' => 'checkbox',
                    'label' => __('انتخاب وضعیت درگاه بانک ملت', 'mrova'),
                    'default' => 'no'),
                'title' => array(
                    'title' => __('عنوان درگاه', 'mrova'),
                    'type'=> 'text',
                    'description' => __('عنوان درگاه در هنگام انتخاب درگاه پرداخت', 'mrova'),
                    'default' => __('پرداخت اینترنتی شتاب - بانک ملت', 'mrova')),
                'description' => array(
                    'title' => __('توضیحات درگاه', 'mrova'),
                    'type' => 'textarea',
                    'description' => __('توضیحات نوشته شده در زیر لوگوی درگاه هنگام پرداخت', 'mrova'),
                    'default' => __('پرداخت با استفاده از درگاه بانک ملت', 'mrova')),
                'terminal_id' => array(
                    'title' => __('ترمینال', 'mrova'),
                    'type' => 'text',
                    'description' => __('شماره پايانه پذيرنده')),
                'username_t' => array(
                    'title' => __('نام کاربری', 'mrova'),
                    'type' => 'text',
                    'description' => __('نام كاربري پذيرنده')),
                'password_t' => array(
                    'title' => __('رمز عبور', 'mrova'),
                    'type' => 'text',
                    'description' => __('كلمه عبور پذيرنده')),
					
				'vahed' => array(
                    'title' => __('واحد پولی'),
                    'type' => 'select',
                    'options' => array(
					'rial' => 'ریال',
					'toman' => 'تومان'
					),
				'description' => __('نیاز به افزونه واحد پولی ریال و تومان دارد')),
				
                'redirect_page_id' => array(
                    'title' => __('برگه بازگشت'),
                    'type' => 'select',
                    'options' => $this -> get_pages('انتخاب برگه'),
                    'description' => "&#1575;&#1583;&#1585;&#1587; &#1576;&#1575;&#1586;&#1711;&#1588;&#1578; &#1575;&#1586; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; &#1583;&#1585; &#1607;&#1606;&#1711;&#1575;&#1605; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578;"
                )
            );


        }
        /**
         * Admin Panel Options
         * - Options for bits like 'title' and availability on a country-by-country basis
         **/
        public function admin_options(){
            echo '<h3>'.__('&#1583;&#1585;&#1711;&#1575;&#1607; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; &#1576;&#1575;&#1606;&#1705; &#1605;&#1604;&#1578;', 'mrova').'</h3>';
            echo '<p>'.__('&#1583;&#1585;&#1711;&#1575;&#1607; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; &#1576;&#1575;&#1606;&#1705; &#1605;&#1604;&#1578; &#1575;&#1740;&#1585;&#1575;&#1606;').'</p>';
            echo '<table class="form-table">';
            $this -> generate_settings_html();
            echo '</table>';

        }
        /**
         *  There are no payment fields for mellat, but we want to show the description if set.
         **/
        function payment_fields(){
            if($this -> description) echo wpautop(wptexturize($this -> description));
        }
        /**
         * Receipt Page
         **/
        function receipt_page($order){
            echo '<p>'.__('&#1575;&#1586; &#1587;&#1601;&#1575;&#1585;&#1588; &#1588;&#1605;&#1575; &#1605;&#1578;&#1588;&#1705;&#1585;&#1740;&#1605;. &#1576;&#1585;&#1575;&#1740; &#1662;&#1585;&#1583;&#1575;&#1582;&#1578; &#1608;&#1580;&#1607; &#1570;&#1606;&#1604;&#1575;&#1740;&#1606; &#1585;&#1608;&#1740; &#1583;&#1705;&#1605;&#1607; &#1586;&#1740;&#1585; &#1705;&#1604;&#1740;&#1705; &#1705;&#1606;&#1740;&#1583;', 'mrova').'</p>';
            echo $this -> generate_mellat_form($order);
        }
        /**
         * Process the payment and return the result
         **/
        function process_payment($order_id){
            $order = &new WC_Order($order_id);
            return array('result' => 'success', 'redirect' => add_query_arg('order',
                $order->id, add_query_arg('key', $order->order_key, get_permalink(get_option('woocommerce_pay_page_id'))))
            );
        }
        /**
         * Check for valid mellat server callback
         **/
       function check_mellat_response(){
        global $woocommerce;
		$client = new nusoap_client('https://bpm.shaparak.ir/pgwchannel/services/pgw?wsdl');
        $namespace='http://interfaces.core.sw.bps.com/';
		$terminalId = $this -> terminal_id;
		$userName = $this -> username_t;
		$userPassword = $this -> password_t;
		$order_id = $woocommerce->session->mellat_woo_id;
		$order = new WC_Order($order_id);
		if($_POST['ResCode']!=0){
		$this -> msg['status'] = 0;
		$this -> msg['message']=$this -> CheckBPMStatus($_POST['ResCode']);
		}
		if($order_id != '' AND $_POST['ResCode']==0){
		if($order -> status !=='completed'){
        $err = $client->getError();
					if ($err)
					{
						$this -> msg['status'] = 0;
						$this -> msg['reversal'] = 1;
						$this -> msg['message'] = $err;
					}
					else
					{
					  	$orderId 				= $_POST[SaleOrderId];
					  	$verifySaleOrderId 		= $_POST[SaleOrderId];
					  	$verifySaleReferenceId 	= $_POST[SaleReferenceId];
					  	
						$parameters = array(
							'terminalId' => $terminalId,
							'userName' => $userName,
							'userPassword' => $userPassword,
							'orderId' => $orderId,
							'saleOrderId' => $verifySaleOrderId,
							'saleReferenceId' => $verifySaleReferenceId);

						// Call the SOAP method
						$result = $client->call('bpVerifyRequest', $parameters, $namespace);

						// Check for a fault
						if ($client->fault)
						{
							$this -> msg['status'] = 0;
							$this -> msg['reversal'] = 1;
							foreach ($result as $error)
								$this -> msg['message'] .= $error;
						}
						else
						{
							$err = $client->getError();
							if ($err)
							{
								$this -> msg['status'] = 0;
								$this -> msg['reversal'] = 1;
								$this -> msg['message'] = $err;
							}
							else 
							{
								if($result == 0)
								{
									// Display the result
									// Update Table, Save Verify Status 
									// Note: Successful Verify means complete successful sale was done.
									$inquirySaleOrderId = $_POST[SaleOrderId];
									$inquirySaleReferenceId = $_POST[SaleReferenceId];

									// Check for an error
									$err = $client->getError();
									if ($err)
									{
										$this -> msg['status'] = 0;
										$this -> msg['reversal'] = 1;
										$this -> msg['message'] = $err;
									}
									else
									{
										$parameters = array(
											'terminalId' => $terminalId,
											'userName' => $userName,
											'userPassword' => $userPassword,
											'orderId' => $orderId,
											'saleOrderId' => $inquirySaleOrderId,
											'saleReferenceId' => $inquirySaleReferenceId);

										// Call the SOAP method
										$result = $client->call('bpInquiryRequest', $parameters, $namespace);
										if($result == 0)
										{
											// Check for a fault
											if ($client->fault)
											{
												$this -> msg['status'] = 0;
												$this -> msg['reversal'] = 1;
												foreach ($result as $error)
													$this -> msg['message'] .= $error;
											}
											else
											{
												$err = $client->getError();
												if ($err)
												{
													$this -> msg['status'] = 0;
													$this -> msg['reversal'] = 1;
													$this -> msg['message'] = $err;
												}
												else
												{
													$this -> msg['status'] = 1;
												}// end Display the result
											}// end Check for errors
										}
										else
										{
											$this -> msg['status'] = 0;
											$this -> msg['reversal'] = 0;
											if (function_exists('CheckBPMStatus'))
												$this -> msg['message'] = $this -> CheckBPMStatus($result);
											else
												$this -> msg['message'] = $result;
										}
									}
								}
								else
								{
									$this -> msg['status'] = 0;
									$this -> msg['reversal'] = 0;
									if (function_exists('CheckBPMStatus'))
										$this -> msg['message'] = $this -> CheckBPMStatus($result);
									else
										$this -> msg['message'] = $result;
								}
							}// end Display the result
						}// end Check for errors
					}
				//-------------- اگر خطایی نبود درخواست واریز وجه داده شود
			if ($this -> msg['status'] == 1)
			{
				// Update Table, Save Inquiry Status 
				// Note: Successful Inquiry means complete successful sale was done.
				$settleSaleOrderId 		= $_POST[SaleOrderId];
				$settleSaleReferenceId 	= $_POST[SaleReferenceId];
				// Check for an error
				$err = $client->getError();
				if ($err) 
				{
					$this -> msg['status'] = 0;
					$this -> msg['message'] = $err;
				}
			  	else
			  	{
					$parameters = array(
						'terminalId' => $terminalId,
						'userName' => $userName,
						'userPassword' => $userPassword,
						'orderId' => $orderId,
						'saleOrderId' => $settleSaleOrderId,
						'saleReferenceId' => $settleSaleReferenceId);
					
					// Call the SOAP method
					$result = $client->call('bpSettleRequest', $parameters, $namespace);
					
					if($result == 0)
					{
						// Check for a fault
						if ($client->fault)
						{
							$this -> msg['status'] = 0;
							foreach ($result as $error)
								$this -> msg['message'] .= $error;
						}
						else
						{
							$err = $client->getError();
							if ($err)
							{
								$this -> msg['reversal'] = 1;
								$this -> msg['status'] = 0;
								$this -> msg['message'] = $err;
							} 
							else 
							{
								// Update Table, Save Settle Status 
								// Note: Successful Settle means that sale is settled.
								unset($woocommerce->session->mellat_woo_id);
								$this -> msg['status'] = 1;
								$this -> msg['message'] ='با تشکر از خرید شما،پرداخت شما انجام گردید <br/> کد پیگیری بانک ملت: '.$verifySaleOrderId .' . شناسه مرجع تراکنش '.$verifySaleReferenceId. 'می باشد';
								$order -> payment_complete();
                                //$order -> add_order_note('پرداخت انجام گردید <br/> کد پیگیری بانک ملت: '.$verifySaleOrderId .' شناسه مرجع تراکنش '.$verifySaleReferenceId );
                                $order -> add_order_note($this -> msg['message']);
                                $woocommerce -> cart -> empty_cart();
							}// end Display the result
						}// end Check for errors
					}
					else
					{
						$this -> msg['status'] = 0;
						$this -> msg['reversal'] = 1;
						if (function_exists('CheckBPMStatus'))
							$this -> msg['message'] = $this ->CheckBPMStatus($result);
						else
							$this -> msg['message'] = $result;
					}
				}
			}
			//------------- در غیر اینصورت وجه برگشت داده شود
			if ($this -> msg['reversal'] == 1)
			{
				$orderId 					= $_POST[SaleOrderId];
			  	$reversalSaleOrderId 		= $_POST[SaleOrderId];
			  	$reversalSaleReferenceId 	= $_POST[SaleReferenceId];

				// Check for an error
				$err = $client->getError();
				if ($err)
				{
					$this -> msg['status'] = 0;
					$this -> msg['message'] = $err;
				}
				else
				{
					$parameters = array(
						'terminalId' => $terminalId,
						'userName' => $userName,
						'userPassword' => $userPassword,
						'orderId' => $orderId,
						'saleOrderId' => $reversalSaleOrderId,
						'saleReferenceId' => $reversalSaleReferenceId);
					// Call the SOAP method
					$result = $client->call('bpReversalRequest', $parameters, $namespace);
					// Check for a fault
					if ($client->fault)
					{
						$this -> msg['status'] = 0;
						foreach ($result as $error)
							$this -> msg['message'] .= $error;
					}
					else
					{
						$err = $client->getError();
						if ($err) {
							// Display the error
							$this -> msg['status'] = 0;
							$this -> msg['message'] = $err;
						}
						else
						{
							// Update Table, Save Reversal Status 
							// Note: Successful Reversal means that sale is reversed.
							if($result == 0)
							{
								$this -> msg['message'] .= '<br />در موقع پرداخت مشکلی به وجود آمد٬ مبلغ پرداخت شده به حساب شما برگشت داده شد.';
							}
							else
							{
								$this -> msg['message'] .= '<br />در موقع پرداخت مشکلی به وجود آمد.';
							}
						}// end Display the result
					}// end Check for errors
				}
			}
			
            }
			
}
if(is_numeric($this -> msg['message'])){
$this -> msg['message']=$this ->CheckBPMStatus($this -> msg['message']);
}
if ($this -> msg['status'] == 0){
				$order -> add_order_note($this -> msg['message']);
				$this -> msg['class']='error';
			}else{
				$this -> msg['class']='success';
			}
				$redirect_url = ($this -> redirect_page_id=="" || $this -> redirect_page_id==0)?get_site_url() . "/":get_permalink($this -> redirect_page_id);
                //For wooCoomerce 2.0
                $redirect_url = add_query_arg( array('msg'=> base64_encode($this -> msg['message']), 'type'=>$this -> msg['class']), $redirect_url );

                wp_redirect( $redirect_url );
                exit;
		
}



        
        /**
         * Generate mellat button link
         **/

      public function generate_mellat_form($order_id){
            global $woocommerce;
            $order = &new WC_Order($order_id);
            $redirect_url = ($this -> redirect_page_id=="" || $this -> redirect_page_id==0)?get_site_url() . "/":get_permalink($this -> redirect_page_id);
			$redirect_url = add_query_arg( 'wc-api', get_class( $this ), $redirect_url );			
			$client = new nusoap_client('https://bpm.shaparak.ir/pgwchannel/services/pgw?wsdl');
		$namespace='http://interfaces.core.sw.bps.com/';
		$terminalId = $this -> terminal_id;
		$userName = $this -> username_t;
		$userPassword = $this -> password_t;
		$orderId=rand(1, 9999999999999);
		unset($woocommerce->session->mellat_woo_id);
		$woocommerce->session->mellat_woo_id = $order_id;
		$amount = str_replace(".00", "", $order -> order_total);;
		if($this -> vahed=='toman')
		$amount = $amount*10;
		$date =  date("ymd");
		$time =  date("His");
		$localDate = $date;
		$localTime = $time;
		$additionalData = '';
		$callBackUrl = $redirect_url;
		$payerId = '0';
		$parameters = array(
			'terminalId' => $terminalId,
			'userName' => $userName,
			'userPassword' => $userPassword,
			'orderId' => $orderId,
			'amount' => $amount,
			'localDate' => $localDate,
			'localTime' => $localTime,
			'additionalData' => $additionalData,
			'callBackUrl' => $callBackUrl,
			'payerId' => $payerId);

		// Call the SOAP method
		$result = $client->call('bpPayRequest', $parameters, $namespace);
		
		// Check for a fault
		if ($client->fault) {
			echo $this ->CheckBPMStatus($_POST['ResCode']);
		} 
		else {
			// Check for errors
			
			$resultStr  = $result;

			$err = $client->getError();
			if ($err) {
				$this -> msg['class'] = 'error';
        $this -> msg['message'] = $err;
			} 
			else {
				// Display the result

				$res = explode (',',$resultStr);

				
				$ResCode = $res[0];
				
				if ($ResCode == "0") {
					
$send_atu="<script language='JavaScript' type='text/javascript'>
<!--
document.getElementById('checkout_confirmation').submit();
//-->
</script>";
echo '
		<form id="checkout_confirmation" method="post" action="https://bpm.shaparak.ir/pgwchannel/startpay.mellat" style="margin:0px"  >
		<input type="hidden"  name="RefId" value="'.$res[1].'" />
		<input type="submit" value="در صورت عدم انتقال اینجا کلیک کنید"  />
		</form>'.$send_atu ;
				} 
				else {
				$this -> msg['class'] = 'error';
				echo $this -> msg['message'] = "اتصال به بانک با مشکل مواجه شد. مشکل را با مدیر سایت در میان بگذارید";
				// log error in app
					// Update table, log the error
					// Show proper message to user
				}
			}// end Display the result
		}// end Check for errors
			
			
			
	if($this -> msg['class']=='error')
	$order -> add_order_note($this->msg['message']);	

        }

	private function western_to_persian($str) {
	$alphabet = array (
		'Û°' => '۰', 'Û±' => '۱', 'Û²' => '۲', 'Û³' => '۳', 'Û´' => '۴', 'Ûµ' => '۵', 'Û¶' => '۶', 'Û·' => '۷', 'Û¸' => '۸',
		'Û¹' => '۹', 'Ø¢' => 'آ', 'Ø§' => 'ا', 'Ø£' => 'أ', 'Ø¥' => 'إ', 'Ø¤' => 'ؤ', 'Ø¦' => 'ئ', 'Ø¡' => 'ء', 'Ø¨' => 'ب',
		'Ù¾' => 'پ', 'Øª' => 'ت', 'Ø«' => 'ث', 'Ø¬' => 'ج', 'Ú†' => 'چ', 'Ø­' => 'ح', 'Ø®' => 'خ', 'Ø¯' => 'د', 'Ø°' => 'ذ',
		'Ø±' => 'ر', 'Ø²' => 'ز', 'Ú˜' => 'ژ', 'Ø³' => 'س', 'Ø´' => 'ش', 'Øµ' => 'ص', 'Ø¶' => 'ض', 'Ø·' => 'ط', 'Ø¸' => 'ظ',
		'Ø¹' => 'ع', 'Øº' => 'غ', 'Ù' => 'ف', 'Ù‚' => 'ق', 'Ú©' => 'ک', 'Ú¯' => 'گ', 'Ù„' => 'ل', 'Ù…' => 'م', 'Ù†' => 'ن',
		'Ùˆ' => 'و', 'Ù‡' => 'ه', 'ÛŒ' => 'ی', 'ÙŠ' => 'ي', 'Û€' => 'ۀ', 'Ø©' => 'ة', 'ÙŽ' => 'َ', 'Ù' => 'ُ', 'Ù' => 'ِ',
		'Ù‘' => 'ّ', 'Ù‹' => 'ً', 'ÙŒ' => 'ٌ', 'Ù' => 'ٍ', 'ØŒ' => '،', 'Ø›' => '؛', ',' => ',', 'ØŸ' => '؟'
	);

	foreach($alphabet as $western => $fa)
		$str = str_replace($western, $fa, $str);

	return $str;
}
private function CheckBPMStatus($ecode)	{
		               //$tmess=western_to_persian("Ø´Ø±Ø­ Ø®Ø·Ø§:");
		               switch ($ecode)
					     {
						  case 0:
					        $tmess=$this ->western_to_persian("ØªØ±Ø§Ú©Ù†Ø´ Ø¨Ø§ Ù…ÙˆÙÙ‚ÙŠØª Ø§Ù†Ø¬Ø§Ù… Ø´Ø¯");
						    break;
						  case 11:
					        $tmess=$this ->western_to_persian("Ø´Ù…Ø§Ø±Ù‡ Ú©Ø§Ø±Øª Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª");
						    break;
						  case 12:
					        $tmess= $this ->western_to_persian("Ù…ÙˆØ¬ÙˆØ¯ÙŠ Ú©Ø§ÙÙŠ Ù†ÙŠØ³Øª");
						    break;
						  case 13:
					        $tmess= $this ->western_to_persian("Ø±Ù…Ø² Ø¯ÙˆÙ… Ø´Ù…Ø§ ØµØ­ÙŠØ­ Ù†ÙŠØ³Øª");
						    break;
						  case 14:
					        $tmess= $this ->western_to_persian("Ø¯ÙØ¹Ø§Øª Ù…Ø¬Ø§Ø² ÙˆØ±ÙˆØ¯ Ø±Ù…Ø² Ø¨ÙŠØ´ Ø§Ø² Ø­Ø¯ Ø§Ø³Øª");
						    break;
						  case 15:
					        $tmess= $this ->western_to_persian("Ú©Ø§Ø±Øª Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª");
						    break;
						  case 16:
					        $tmess= $this ->western_to_persian("Ø¯ÙØ¹Ø§Øª Ø¨Ø±Ø¯Ø§Ø´Øª ÙˆØ¬Ù‡ Ø¨ÙŠØ´ Ø§Ø² Ø­Ø¯ Ù…Ø¬Ø§Ø² Ø§Ø³Øª");
						    break;
						  case 17:
					        $tmess= $this ->western_to_persian("Ú©Ø§Ø±Ø¨Ø± Ø§Ø² Ø§Ù†Ø¬Ø§Ù… ØªØ±Ø§Ú©Ù†Ø´ Ù…Ù†ØµØ±Ù Ø´Ø¯Ù‡ Ø§Ø³Øª");
						    break;
						  case 18:
					        $tmess= $this ->western_to_persian("ØªØ§Ø±ÙŠØ® Ø§Ù†Ù‚Ø¶Ø§ÙŠ Ú©Ø§Ø±Øª Ú¯Ø°Ø´ØªÙ‡ Ø§Ø³Øª");
						    break;
						  case 19:
					        $tmess= $this ->western_to_persian("Ù…Ø¨Ù„Øº Ø¨Ø±Ø¯Ø§Ø´Øª ÙˆØ¬Ù‡ Ø¨ÙŠØ´ Ø§Ø² Ø­Ø¯ Ù…Ø¬Ø§Ø² Ø§Ø³Øª");
						    break;
						  case 111:
					        $tmess= $this ->western_to_persian("ØµØ§Ø¯Ø± Ú©Ù†Ù†Ø¯Ù‡ Ú©Ø§Ø±Øª Ù†Ø§Ù…Ø¹ØªØ¨Ø± Ø§Ø³Øª");
						    break;
						  case 112:
					        $tmess= $this ->western_to_persian("Ø®Ø·Ø§ÙŠ Ø³ÙˆÙŠÙŠÚ† ØµØ§Ø¯Ø± Ú©Ù†Ù†Ø¯Ù‡ Ú©Ø§Ø±Øª");
						    break;
						  case 113:
					        $tmess= $this ->western_to_persian("Ù¾Ø§Ø³Ø®ÙŠ Ø§Ø² ØµØ§Ø¯Ø± Ú©Ù†Ù†Ø¯Ù‡ Ú©Ø§Ø±Øª Ø¯Ø±ÙŠØ§ÙØª Ù†Ø´Ø¯");
						    break;
						  case 114:
					        $tmess= $this ->western_to_persian("Ø¯Ø§Ø±Ù†Ø¯Ù‡ Ú©Ø§Ø±Øª Ù…Ø¬Ø§Ø² Ø¨Ù‡ Ø§Ù†Ø¬Ø§Ù… Ø§ÙŠÙ† ØªØ±Ø§Ú©Ù†Ø´ Ù†Ù…ÙŠ Ø¨Ø§Ø´Ø¯");
						    break;
						  case 21:
					        $tmess= $this ->western_to_persian("Ù¾Ø°ÙŠØ±Ù†Ø¯Ù‡ Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª");
						    break;
						  case 23:
					        $tmess= $this ->western_to_persian("Ø®Ø·Ø§ÙŠ Ø§Ù…Ù†ÙŠØªÙŠ Ø±Ø® Ø¯Ø§Ø¯Ù‡ Ø§Ø³Øª");
						    break;
						  case 24:
					        $tmess= $this ->western_to_persian("Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ú©Ø§Ø±Ø¨Ø±ÙŠ Ù¾Ø°ÙŠØ±Ù†Ø¯Ù‡ Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª");
						    break;
						  case 25:
					        $tmess= $this ->western_to_persian("Ù…Ø¨Ù„Øº Ù†Ø§Ù…Ø¹ØªØ¨Ø± Ø§Ø³Øª");
						    break;
						  case 31:
					        $tmess= $this ->western_to_persian("Ù¾Ø§Ø³Ø® Ù†Ø§Ù…Ø¹ØªØ¨Ø± Ø§Ø³Øª");
						    break;
						  case 32:
					        $tmess= $this ->western_to_persian("ÙØ±Ù…Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª ÙˆØ§Ø±Ø¯ Ø´Ø¯Ù‡ ØµØ­ÙŠØ­ Ù†ÙŠØ³Øª");
						    break;
						  case 33:
					        $tmess=$this ->western_to_persian("Ø­Ø³Ø§Ø¨ Ù†Ø§Ù…Ø¹ØªØ¨Ø± Ø§Ø³Øª");
						    break;
						  case 34:
					        $tmess= $this ->western_to_persian("Ø®Ø·Ø§ÙŠ Ø³ÙŠØ³ØªÙ…ÙŠ");
						    break;
						  case 35:
					        $tmess= $this ->western_to_persian("ØªØ§Ø±ÙŠØ® Ù†Ø§Ù…Ø¹ØªØ¨Ø± Ø§Ø³Øª");
						    break;
						  case 41:
					        $tmess= $this ->western_to_persian("Ø´Ù…Ø§Ø±Ù‡ Ø¯Ø±Ø®ÙˆØ§Ø³Øª ØªÚ©Ø±Ø§Ø±ÙŠ Ø§Ø³Øª");
						    break;
						  case 42:
					        $tmess= $this ->western_to_persian("ØªØ±Ø§Ú©Ù†Ø´ Sale ÙŠØ§ÙØª Ù†Ø´Ø¯");
						    break;
						  case 43:
					        $tmess= $this ->western_to_persian("Ù‚Ø¨Ù„Ø§ Ø¯Ø±Ø®ÙˆØ§Ø³Øª Verify Ø¯Ø§Ø¯Ù‡ Ø´Ø¯Ù‡ Ø§Ø³Øª");
						    break;
						  case 44:
					        $tmess= $this ->western_to_persian("Ø¯Ø±Ø®ÙˆØ§Ø³Øª Verify ÙŠØ§ÙØª Ù†Ø´Ø¯");
						    break;
						  case 45:
					        $tmess= $this ->western_to_persian("ØªØ±Ø§Ú©Ù†Ø´ Settle Ø´Ø¯Ù‡ Ø§Ø³Øª");
						    break;
						  case 46:
					        $tmess= $this ->western_to_persian("ØªØ±Ø§Ú©Ù†Ø´ Settle Ù†Ø´Ø¯Ù‡ Ø§Ø³Øª");
						    break;
						  case 47:
					        $tmess= $this ->western_to_persian("ØªØ±Ø§Ú©Ù†Ø´ Settle ÙŠØ§ÙØª Ù†Ø´Ø¯");
						    break;
						  case 48:
					        $tmess= $this ->western_to_persian("ØªØ±Ø§Ú©Ù†Ø´ Reverse Ø´Ø¯Ù‡ Ø§Ø³Øª");
						    break;
						  case 49:
					        $tmess= $this ->western_to_persian("ØªØ±Ø§Ú©Ù†Ø´ Refund ÙŠØ§ÙØª Ù†Ø´Ø¯");
						    break;
						  case 412:
					        $tmess= $this ->western_to_persian("Ø´Ù†Ø§Ø³Ù‡ Ù‚Ø¨Ø¶ Ù†Ø§Ø¯Ø±Ø³Øª Ø§Ø³Øª");
						    break;
						  case 413:
					        $tmess= $this ->western_to_persian("Ø´Ù†Ø§Ø³Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ù†Ø§Ø¯Ø±Ø³Øª Ø§Ø³Øª");
						    break;
						  case 414:
					        $tmess= $this ->western_to_persian("Ø³Ø§Ø²Ù…Ø§Ù† ØµØ§Ø¯Ø± Ú©Ù†Ù†Ø¯Ù‡ Ù‚Ø¨Ø¶ Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª");
						    break;
						  case 415:
					        $tmess= $this ->western_to_persian("Ø²Ù…Ø§Ù† Ø¬Ù„Ø³Ù‡ Ú©Ø§Ø±ÙŠ Ø¨Ù‡ Ù¾Ø§ÙŠØ§Ù† Ø±Ø³ÙŠØ¯Ù‡ Ø§Ø³Øª");
						    break;
						  case 416:
					        $tmess= $this ->western_to_persian("Ø®Ø·Ø§ Ø¯Ø± Ø«Ø¨Øª Ø§Ø·Ù„Ø§Ø¹Ø§Øª");
						    break;
						  case 417:
					        $tmess= $this ->western_to_persian("Ø´Ù†Ø§Ø³Ù‡ Ù¾Ø±Ø¯Ø§Ø®Øª Ú©Ù†Ù†Ø¯Ù‡ Ù†Ø§Ù…Ø¹ØªØ¨Ø± Ø§Ø³Øª");
						    break;
						  case 418:
					        $tmess= $this ->western_to_persian("Ø§Ø´Ú©Ø§Ù„ Ø¯Ø± ØªØ¹Ø±ÙŠÙ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ù…Ø´ØªØ±ÙŠ");
						    break;
						  case 419:
					        $tmess= $this ->western_to_persian("ØªØ¹Ø¯Ø§Ø¯ Ø¯ÙØ¹Ø§Øª ÙˆØ±ÙˆØ¯ Ø§Ø·Ù„Ø§Ø¹Ø§Øª Ø¨ÙŠØ´ Ø§Ø² Ø­Ø¯ Ù…Ø¬Ø§Ø² Ø§Ø³Øª");
						    break;
						  case 421:
					        $tmess= $this ->western_to_persian("IP Ù…Ø¹ØªØ¨Ø± Ù†ÙŠØ³Øª");
						    break;
						  case 51:
					        $tmess= $this ->western_to_persian("ØªØ±Ø§Ú©Ù†Ø´ ØªÚ©Ø±Ø§Ø±ÙŠ Ø§Ø³Øª");
						    break;
						  case 54:
					        $tmess= $this ->western_to_persian("ØªØ±Ø§Ú©Ù†Ø´ Ù…Ø±Ø¬Ø¹ Ù…ÙˆØ¬ÙˆØ¯ Ù†ÙŠØ³Øª");
						    break;
						  case 55:
					        $tmess= $this ->western_to_persian("ØªØ±Ø§Ú©Ù†Ø´ Ù†Ø§Ù…Ø¹ØªØ¨Ø± Ø§Ø³Øª");
						    break;
						  case 61:
					        $tmess= $this ->western_to_persian("Ø®Ø·Ø§ Ø¯Ø± ÙˆØ§Ø±ÙŠØ²");
						    break;
						 }
		return $tmess;
	}
        // get all pages
        function get_pages($title = false, $indent = true) {
            $wp_pages = get_pages('sort_column=menu_order');
            $page_list = array();
            if ($title) $page_list[] = $title;
            foreach ($wp_pages as $page) {
                $prefix = '';
                // show indented child pages?
                if ($indent) {
                    $has_parent = $page->post_parent;
                    while($has_parent) {
                        $prefix .=  ' - ';
                        $next_page = get_page($has_parent);
                        $has_parent = $next_page->post_parent;
                    }
                }
                // add to page list array array
                $page_list[$page->ID] = $prefix . $page->post_title;
            }
            return $page_list;
        }

    }

    /**
     * Add the Gateway to WooCommerce
     **/
    function woocommerce_add_mellat_gateway($methods) {
        $methods[] = 'WC_Mellat_Pay';
        return $methods;
    }

    add_filter('woocommerce_payment_gateways', 'woocommerce_add_mellat_gateway' );
}

?>
